VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TradeAPI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public WithEvents TradeAPI As TCTradeWrapperAPILib.CTCTradeAPIEx
Attribute TradeAPI.VB_VarHelpID = -1

Public Event OnMessage(ByVal nMsgType As Long, ByVal nMsgCode As Long, ByVal strMsgString As String)

Public Event OnConnect()
Public Event OnDisConnect()
Public Event OnAccountList(ByVal index As Integer, ByVal accountlistitem As TCTradeWrapperAPILib.ADIAccount)

Public Event OnMargin(ByVal index As Integer, ByVal AccMask As String, ByVal marginitem As TCTradeWrapperAPILib.ADIMargin)
Public Event OnPosition(ByVal index As Integer, ByVal AccMask As String, ByVal positionitem As TCTradeWrapperAPILib.ADIPosition)
Public Event OnComPosition(ByVal index As Integer, ByVal AccMask As String, ByVal compositionitem As TCTradeWrapperAPILib.ADIPosition)

Public Event OnRealOrderReport(ByVal reportitem As TCTradeWrapperAPILib.RPTExecutionReport)
Public Event OnRealFilledReport(ByVal fillitem As TCTradeWrapperAPILib.RptFilledOrder)
Public Event OnComOrderReport(ByVal index As Integer, ByVal AccMask As String, ByVal compositionitem As TCTradeWrapperAPILib.adiCombinationOrderItem)

Public Event OnOrderReport(ByVal index As Integer, ByVal reportitem As TCTradeWrapperAPILib.RPTExecutionReport)
Public Event OnFilledReport(ByVal index As Integer, ByVal fillitem As TCTradeWrapperAPILib.RptFilledOrder)
Public Event OnPositionMonitor(ByVal posmonitoritem As TCTradeWrapperAPILib.adiPositionTracker)
Public Event OnReportReset()

Public Event OnSymbol(ByVal symboljson As String)

Private accountlistitem As TCTradeWrapperAPILib.ADIAccount
Public marginitem As TCTradeWrapperAPILib.ADIMargin
Public positionitem As TCTradeWrapperAPILib.ADIPosition
Public combinationorderitem As TCTradeWrapperAPILib.adiCombinationOrderItem

Public orderreport As TCTradeWrapperAPILib.RPTReports
Public orderreportitem As TCTradeWrapperAPILib.RPTExecutionReport
Public fillreportitem As TCTradeWrapperAPILib.RptFilledOrder
Public posmonitoritem As TCTradeWrapperAPILib.adiPositionTracker

Public neworderitem As TCTradeWrapperAPILib.NOPFutOpt
Public replaceorderitem As TCTradeWrapperAPILib.NOPReplaceOrder
Public accncount As Integer
Public accdatacout As Variant
Public connectstatus As Boolean

Private Sub Class_Initialize()
    If TypeName(TradeAPI) = "Nothing" Then
        Set TradeAPI = New TCTradeWrapperAPILib.CTCTradeAPIEx
    End If
    If TypeName(accdatacout) = "Nothing" Then
        Set accdatacout = CreateObject("Scripting.Dictionary")
    End If
    connectstatus = False
   
End Sub


Private Sub Class_Terminate()
    Call TradeAPI.DisConnect
    connectstatus = False
End Sub

Public Sub TradeAPI_OnCommandMsg(ByVal nMsgType As Long, ByVal nMsgCode As Long, ByVal strMsgString As String)
    Dim i As Integer
    Dim item As Variant
    If nMsgType = 2 And nMsgCode = 1 Then
        RaiseEvent OnConnect
        connectstatus = True
        Application.Wait Now() + CDate("00:00:02")
        i = 0
        Do While True
            If TypeName(accountlistitem) = "Nothing" Then
                Set accountlistitem = New TCTradeWrapperAPILib.ADIAccount
            End If
            Call TradeAPI.GetAccountData(1, i, "", accountlistitem)
            If accountlistitem.Account = "" Then
                Exit Do
            Else
                RaiseEvent OnAccountList(i, accountlistitem)
                Set accountlistitem = Nothing
                i = i + 1
            End If
        Loop
    ElseIf nMsgType = 1 And nMsgCode = 1 Then
        RaiseEvent OnDisConnect
    ElseIf nMsgType = 2 And nMsgCode = 11 And InStr(strMsgString, "BrokerName") And InStr(strMsgString, "LoginID") Then
        i = 0
        Do While True
            If TypeName(accountlistitem) = "Nothing" Then
                Set accountlistitem = New TCTradeWrapperAPILib.ADIAccount
            End If
            Call TradeAPI.GetAccountData(1, i, "", accountlistitem)
            If accountlistitem.Account = "" Then
                Exit Do
            Else
                RaiseEvent OnAccountList(i, accountlistitem)
                Set accountlistitem = Nothing
                i = i + 1
            End If
        Loop
    Else
        RaiseEvent OnMessage(nMsgType, nMsgCode, strMsgString)
    End If
End Sub


Private Sub TradeAPI_OnExecutionReport(ByVal strReportID As String)
    If TypeName(orderreportitem) = "Nothing" Then
        Set orderreportitem = New TCTradeWrapperAPILib.RPTExecutionReport
    End If
    Call TradeAPI.GetReportData(0, strReportID, orderreportitem)
    RaiseEvent OnRealOrderReport(orderreportitem)
    Set orderreportitem = Nothing
End Sub

Private Sub TradeAPI_OnFilledReport(ByVal strReportID As String)
    If TypeName(fillreportitem) = "Nothing" Then
        Set fillreportitem = New TCTradeWrapperAPILib.RptFilledOrder
    End If
    Call TradeAPI.GetReportData(0, strReportID, fillreportitem)
    RaiseEvent OnRealFilledReport(fillreportitem)
    Set fillreportitem = Nothing
End Sub

Private Sub TradeAPI_OnReportReset()
    RaiseEvent OnReportReset
End Sub

Private Sub TradeAPI_OnSetTopic(ByVal strTopic As String, ByVal lParam As Long, ByVal strParam As String, pvParam)
    Dim pathlist() As String
    Dim path As String
    Dim todaypath  As String
    pathlist = Split(pvParam, "\")
    todaypath = pathlist(0) + "\" + pathlist(1) + "\" + pathlist(2) + "\TCoreRelease\Configs\ContractList_" + strParam + ".ini"

    If Dir(pvParam, vbDirectory) <> "" Then
        path = pvParam
    ElseIf Dir(todaypath, vbDirectory) <> "" Then
        path = todaypath
    End If
    
    
    Dim fso As Object
    Dim txtStream As Object
    Set fso = CreateObject("Scripting.FileSystemObject")

    Set txtStream = fso.OpenTextFile(path, 1, False, -1)
    RaiseEvent OnSymbol(txtStream.readall)
     Set fso = Nothing
     Set txtStream = Nothing

    TradeAPI.TopicUnsub ("ICECREAM.RETURN")
End Sub



'
Public Sub Connect(Optional appid As String = "AlgoMaster2DEV")
    If connectstatus = False Then
        Call TradeAPI.Connect(".", appid, "8076c9867a372d2a9a814ae710c256e2", 1)
        Call TradeAPI.SetAccountSubscriptionLevel(3)
    End If
End Sub

Public Sub DisConnect()
    If connectstatus = True Then
        Call TradeAPI.DisConnect
    End If
    connectstatus = False

End Sub

Public Sub ReqAccountList()
    Dim i As Integer
    i = 0
    Do While True
        If TypeName(accountlistitem) = "Nothing" Then
            Set accountlistitem = New TCTradeWrapperAPILib.ADIAccount
        End If
        Call TradeAPI.GetAccountData(1, i, "", accountlistitem)
        If accountlistitem.Account = "" Then
            Exit Do
        Else
            RaiseEvent OnAccountList(i, accountlistitem)
            Set accountlistitem = Nothing
            i = i + 1
        End If
    Loop

End Sub

Public Function neworder(ByVal Account As String, ByVal BrokerID As String, ByVal symbol As String, ByVal Side As Long, ByVal OrderQty As Long, ByVal OrderType As Long, ByVal TimeInForce As Long, _
ByVal PositionEffect As Long, Optional Price As String = "", Optional StopPrice As String = "", Optional ContingentSymbol As String = "", Optional GroupID As String = "", Optional ordid As String = "", Optional UserKey2 As String = "", _
Optional Strategy As String = "", Optional ChasePrice As String = "", Optional TouchPrice As String = "", Optional TouchField As Long = 0, Optional TouchCondition As Long = 0, Optional Exchange As String = "", Optional Breakeven As String = "", _
Optional BreakevenOffset As String = "", Optional FlowControl As Long = 0, Optional FitOrderFreq As Long = 0, Optional DelayTransPosition As Long = 0, Optional SelfTradePrevention As Long = 0, _
Optional ExtCommands As String = "", Optional GrpAcctOrdType As Long = 0, Optional SpreadType As Long = 0, Optional Synthetic As Long = 0, Optional symbola As String = "", Optional SymbolB As String = "", _
Optional Security As String = "", Optional Security2 As String = "", Optional Month As String = "", Optional Month2 As String = "", Optional CallPut As String = "", Optional CallPut2 As String = "", Optional Side1 As Long = 0, _
Optional Side2 As Long = 0, Optional TrailingField As Long = 0, Optional TrailingType As Long = 0, Optional TrailingAmount As Long = 0, Optional SlicedType As Long = 0, Optional SlicedPriceField As Long = 0, _
Optional SlicedTicks As Long = 0, Optional DayTrade As Long = 0, Optional GroupType As Long = 0, Optional DiscloseQty As Long = 0, Optional Variance As Long = 0, Optional Interval As Long = 0, _
Optional LeftoverAction As Long = 0, Optional Threshold As Long = 0, Optional Consecutive As Long = 0, Optional NumberOfRetries As Long = 0, Optional StrikePrice As Long = 0, Optional StrikePrice2 As Long = 0)

    Set neworderitem = New TCTradeWrapperAPILib.NOPFutOpt
    neworderitem.Account = Account
    neworderitem.BrokerID = BrokerID
    neworderitem.symbol = symbol
    neworderitem.Side = Side
    neworderitem.OrderQty = OrderQty
    neworderitem.OrderType = OrderType
    neworderitem.TimeInForce = TimeInForce
    neworderitem.PositionEffect = PositionEffect
    If InStr(Price, "-") Or InStr(Price, "+") Or Len(Price) = 0 Then
        neworderitem.Price = Price
    Else:
        neworderitem.Price = Format(Val(Price) * 10000000000#, "0")
    End If
    If InStr(StopPrice, "-") Or InStr(StopPrice, "+") Or Len(StopPrice) = 0 Then
        neworderitem.StopPrice = StopPrice
    Else:
        neworderitem.StopPrice = Format(Val(StopPrice) * 10000000000#, "0")
    End If
    neworderitem.ContingentSymbol = ContingentSymbol
    neworderitem.GroupID = GroupID
    neworderitem.UserKey1 = ordid
    neworderitem.UserKey2 = UserKey2
'    neworderitem.UserKey3=UserKey3
    neworderitem.Strategy = Strategy
    neworderitem.ChasePrice = ChasePrice
    If InStr(TouchPrice, "-") Or InStr(TouchPrice, "+") Or Len(TouchPrice) = 0 Then
        neworderitem.TouchPrice = TouchPrice
    Else:
        neworderitem.TouchPrice = Format(Val(TouchPrice) * 10000000000#, "0")
    End If
    neworderitem.TouchField = TouchField
    neworderitem.TouchCondition = TouchCondition
    neworderitem.Exchange = Exchange
    neworderitem.Breakeven = Breakeven
    neworderitem.BreakevenOffset = BreakevenOffset
    neworderitem.ExtCommands = ExtCommands + ",SelfTradePrevention=" + Str(SelfTradePrevention) + ",FlowControl=" + Str(FlowControl) + ",FitOrderFreq=" + Str(FitOrderFreq) + ",FitOrderFreq=" + Str(DelayTransPosition)
    neworderitem.GrpAcctOrdType = GrpAcctOrdType
    neworderitem.SpreadType = SpreadType
    neworderitem.Synthetic = Synthetic
    neworderitem.symbola = symbola
    neworderitem.SymbolB = SymbolB
    neworderitem.Security = Security
    neworderitem.Security2 = Security2
    neworderitem.Month = Month
    neworderitem.Month2 = Month2
    neworderitem.CallPut = CallPut
    neworderitem.CallPut2 = CallPut2
    neworderitem.Side1 = Side1
    neworderitem.Side2 = Side2
    neworderitem.TrailingField = TrailingField
    neworderitem.TrailingType = TrailingType
    neworderitem.TrailingAmount = TrailingAmount
    neworderitem.SlicedType = SlicedType
    neworderitem.SlicedPriceField = SlicedPriceField
    neworderitem.SlicedTicks = SlicedTicks
    neworderitem.DayTrade = DayTrade
    neworderitem.GroupType = GroupType
    neworderitem.DiscloseQty = DiscloseQty
    neworderitem.Variance = Variance
    neworderitem.Interval = Interval
    neworderitem.LeftoverAction = LeftoverAction
    neworderitem.Threshold = Threshold
    neworderitem.Consecutive = Consecutive
    neworderitem.NumberOfRetries = NumberOfRetries

    If InStr(neworderitem.symbol, "TC.F") Or InStr(neworderitem.symbol, "TC.O") Then
        Call TradeAPI.NewOrder2(9, neworderitem)
        Set neworderitem = Nothing
    Else
        MsgBox ("ֻµڻԼ")
    
    End If
   
End Function


Public Function NewOrder2(ByVal orderitem As TCTradeWrapperAPILib.NOPFutOpt)
'    Set neworderitem = New TCTradeWrapperAPILib.NOPFutOpt
     If InStr(orderitem.symbol, "TC.F") Or InStr(orderitem.symbol, "TC.O") Then

        If Not InStr(orderitem.Price, "-") And Not InStr(orderitem.Price, "+") And Not Len(orderitem.Price) = 0 Then
            orderitem.Price = Format(Val(orderitem.Price) * 10000000000#, "0")
        End If
        
        If Not InStr(orderitem.StopPrice, "-") And Not InStr(orderitem.StopPrice, "+") And Not Len(orderitem.StopPrice) = 0 Then
            orderitem.StopPrice = Format(Val(orderitem.StopPrice) * 10000000000#, "0")
        End If
        
        If Not InStr(orderitem.TouchPrice, "-") And Not InStr(orderitem.TouchPrice, "+") And Not Len(orderitem.TouchPrice) = 0 Then
            orderitem.TouchPrice = Format(Val(orderitem.TouchPrice) * 10000000000#, "0")
        End If
    
        Call TradeAPI.NewOrder2(9, orderitem)
     Else
         MsgBox ("ֻµڻȨԼ")
   
     End If
End Function


Public Function CancelOrder(ByVal reportid As String)
    Call TradeAPI.CancelOrder(reportid, "")
End Function


Public Function RepalceOrder(ByVal orderitem As TCTradeWrapperAPILib.NOPReplaceOrder)
        If orderitem.Price <> "-9223372036854775808" Then
            orderitem.Price = Val(orderitem.Price) * 10000000000#
        End If
        If orderitem.StopPrice <> "-9223372036854775808" Then
            orderitem.StopPrice = Val(orderitem.StopPrice) * 10000000000#
        End If
        If Not InStr(orderitem.TouchPrice, "-") And Not InStr(orderitem.TouchPrice, "+") And Not Len(orderitem.TouchPrice) = 0 Then
            orderitem.TouchPrice = Format(Val(orderitem.TouchPrice) * 10000000000#, "0")
        End If
    
    Call TradeAPI.replaceorder(orderitem)
End Function

  
Public Sub ReqAccmargin(Optional AccMask As String = "")
    Dim i As Integer
    Dim j As Integer
    Dim m As Integer
    i = 0
    m = 0
    If AccMask = "" Then
        While True
            If TypeName(accountlistitem) = "Nothing" Then
                Set accountlistitem = New TCTradeWrapperAPILib.ADIAccount
            End If
            Call TradeAPI.GetAccountData(1, i, "", accountlistitem)
            If accountlistitem.Account = "" Then
                GoTo lab1
            Else
                j = 0
                Do While True
                    If TypeName(marginitem) = "Nothing" Then
                        Set marginitem = New TCTradeWrapperAPILib.ADIMargin
                    End If
                    Call TradeAPI.GetAccountData(9, j, accountlistitem.BrokerID + "-" + accountlistitem.Account, marginitem)
'                    Debug.Print (marginitem.Account + "   " + marginitem.BrokerID + "   " + Str(marginitem.CurrMargin) + "  " + marginitem.CurrencyToClient)
                    If marginitem.Account = "" Then
                        Set accountlistitem = Nothing
                        Exit Do
                    Else
                        RaiseEvent OnMargin(j, AccMask, marginitem)
                        Set marginitem = Nothing
                        j = j + 1
                        m = m + 1
                    End If
                Loop
            End If
            i = i + 1
        Wend
    Else
        j = 0
        Do While True
            If TypeName(marginitem) = "Nothing" Then
                Set marginitem = New TCTradeWrapperAPILib.ADIMargin
            End If
            Call TradeAPI.GetAccountData(9, j, AccMask, marginitem)
            If marginitem.Account = "" Then
                Exit Do
            Else
                RaiseEvent OnMargin(j, AccMask, marginitem)
                Set marginitem = Nothing
                j = j + 1
            End If
        Loop
    End If
    
lab1:

End Sub

Public Sub ReqPosition(Optional AccMask As String = "")
    Dim i As Integer
    Dim j As Integer
    Dim m As Integer
    i = 0
    m = 0
    If AccMask = "" Then
        While True
'           DoEvents
            If TypeName(accountlistitem) = "Nothing" Then
                Set accountlistitem = New TCTradeWrapperAPILib.ADIAccount
            End If
            Call TradeAPI.GetAccountData(1, i, "", accountlistitem)
            If accountlistitem.Account = "" Then
                GoTo lab1
            Else
                j = 0
                Do While True
'                    DoEvents
                    If TypeName(positionitem) = "Nothing" Then
                        Set positionitem = New TCTradeWrapperAPILib.ADIPosition
                    End If
                    Call TradeAPI.GetAccountData(7, j, accountlistitem.BrokerID + "-" + accountlistitem.Account, positionitem)
                    
                    If positionitem.Account = "" Then
                        Set accountlistitem = Nothing
                        Exit Do
                    Else
                        RaiseEvent OnPosition(j, accountlistitem.BrokerID + "-" + accountlistitem.Account, positionitem)
                        Set positionitem = Nothing
                        j = j + 1
                        m = m + 1
                    End If
                Loop
            End If
            i = i + 1
        Wend
    Else
        j = 0
        Do While True
'            DoEvents
            If TypeName(positionitem) = "Nothing" Then
                Set positionitem = New TCTradeWrapperAPILib.ADIPosition
            End If
            Call TradeAPI.GetAccountData(7, j, AccMask, positionitem)
            If positionitem.Account = "" Then
                Exit Do
            Else
                RaiseEvent OnPosition(j, AccMask, positionitem)
                Set positionitem = Nothing
                j = j + 1
            End If
        Loop
    End If
lab1:

End Sub

Public Sub ReqPositionMonitor()

Set posmonitoritem = New TCTradeWrapperAPILib.adiPositionTracker
Call TradeAPI.GetPositionTracker(posmonitoritem)
RaiseEvent OnPositionMonitor(posmonitoritem)
Set posmonitoritem = Nothing
End Sub


Public Sub ReqCombPosition(Optional AccMask As String = "")
    Dim i As Integer
    Dim j As Integer
    Dim m As Integer
    i = 0
    m = 0
    If AccMask = "" Then
        While True
'            DoEvents
            If TypeName(accountlistitem) = "Nothing" Then
                Set accountlistitem = New TCTradeWrapperAPILib.ADIAccount
            End If
            Call TradeAPI.GetAccountData(1, i, "", accountlistitem)
            If accountlistitem.Account = "" Then
                GoTo lab1
            Else
                j = 0
                Do While True
'                    DoEvents
                    If TypeName(positionitem) = "Nothing" Then
                        Set positionitem = New TCTradeWrapperAPILib.ADIPosition
                    End If
                    Call TradeAPI.GetAccountData(8, j, accountlistitem.BrokerID + "-" + accountlistitem.Account, positionitem)
                    If positionitem.Account = "" Then
                        Set accountlistitem = Nothing
                        Exit Do
                    Else
                        If InStr(positionitem.symbol, "^") Then
                            RaiseEvent OnComPosition(m, accountlistitem.BrokerID + "-" + accountlistitem.Account, positionitem)
                            m = m + 1
                         End If
                        Set positionitem = Nothing
                        j = j + 1
                    End If
                Loop
            End If
            i = i + 1
        Wend
    Else
        j = 0
        m = 0
        Do While True
'            DoEvents
            If TypeName(positionitem) = "Nothing" Then
                Set positionitem = New TCTradeWrapperAPILib.ADIPosition
            End If
            Call TradeAPI.GetAccountData(7, j, AccMask, positionitem)
            If positionitem.Account = "" Then
                Exit Do
            Else
            If InStr(positionitem.symbol, "^") Then
                RaiseEvent OnComPosition(m, AccMask, positionitem)
                m = m + 1
            End If
            Set positionitem = Nothing
            j = j + 1
            End If
        Loop
    End If
lab1:

End Sub

Public Sub ReqCombinationOrder(Optional AccMask As String = "")
    Dim i As Integer
    Dim j As Integer
    Dim m As Integer
    i = 0
    m = 0
    If AccMask = "" Then
        While True
            If TypeName(accountlistitem) = "Nothing" Then
                Set accountlistitem = New TCTradeWrapperAPILib.ADIAccount
            End If
            Call TradeAPI.GetAccountData(1, i, "", accountlistitem)
            If accountlistitem.Account = "" Then
                GoTo lab1
            Else
                j = 0
                Do While True
                    If TypeName(combinationorderitem) = "Nothing" Then
                        Set combinationorderitem = New TCTradeWrapperAPILib.adiCombinationOrderItem
                    End If
                    Call TradeAPI.GetAccountData(32, j, accountlistitem.BrokerID + "-" + accountlistitem.Account, combinationorderitem)
                    If combinationorderitem.GetItemData("Account") = "" Then
                        Set accountlistitem = Nothing
                        Exit Do
                    Else
                        RaiseEvent OnComOrderReport(m, accountlistitem.BrokerID + "-" + accountlistitem.Account, combinationorderitem)
                        Set combinationorderitem = Nothing
                        j = j + 1
                        m = m + 1
                    End If
                Loop
            End If
            i = i + 1
        Wend
    Else
        j = 0
        Do While True
            If TypeName(combinationorderitem) = "Nothing" Then
                        Set combinationorderitem = New TCTradeWrapperAPILib.adiCombinationOrderItem
            End If
            Call TradeAPI.GetAccountData(32, j, AccMask, combinationorderitem)
            If combinationorderitem.GetItemData("Account") = "" Then
                Set accountlistitem = Nothing
                Exit Do
            Else
                RaiseEvent OnComOrderReport(j, AccMask, combinationorderitem)
                Set combinationorderitem = Nothing
                j = j + 1
            End If
        Loop
    End If
lab1:

End Sub

Public Sub ReqOrderReport()
    Dim i As Integer
    Dim re As Variant
    If TypeName(orderreport) = "Nothing" Then
        Set orderreport = New TCTradeWrapperAPILib.RPTReports
    End If
    If TypeName(orderreportitem) = "Nothing" Then
        Set orderreportitem = New TCTradeWrapperAPILib.RPTExecutionReport
    End If
    
    re = TradeAPI.GetReportData(3, "", orderreport)
    If re = 1 Then
        For i = 0 To orderreport.Count - 1
'                DoEvents
                Call TradeAPI.GetReportData(0, orderreport.GetReportID(i), orderreportitem)
                RaiseEvent OnOrderReport(i, orderreportitem)
        Next
        Set orderreport = Nothing
        Set orderreportitem = Nothing
    End If

End Sub

Public Sub ReqFillReport()
    Dim i As Integer
    Dim j As Integer
    Dim re As Variant
    If TypeName(orderreport) = "Nothing" Then
        Set orderreport = New TCTradeWrapperAPILib.RPTReports
    End If
    If TypeName(orderreportitem) = "Nothing" Then
        Set orderreportitem = New TCTradeWrapperAPILib.RPTExecutionReport
    End If
    If TypeName(fillreportitem) = "Nothing" Then
        Set fillreportitem = New TCTradeWrapperAPILib.RptFilledOrder
    End If

    re = TradeAPI.GetReportData(2, "", orderreport)
    If re = 1 Then
        For i = 0 To orderreport.Count - 1
            Call TradeAPI.GetReportData(0, orderreport.GetReportID(i), orderreportitem)
            For j = 0 To orderreportitem.FilledOrdersCount - 1
                Call TradeAPI.GetReportData(0, orderreportitem.GetFilledOrderReportID(j), fillreportitem)
                RaiseEvent OnFilledReport(i, fillreportitem)
            Next
        Next
        Set orderreport = Nothing
        Set fillreportitem = Nothing
    End If
End Sub

Public Function GetSymbol(Optional symboltype As String = "", Optional Exchange As String = "", Optional symbolmonth As String = "", Optional strdate As String = "", Optional CallPut As String = "")
    GetSymbol = TradeAPI.GetSymbolClassifications(symboltype, Exchange, symbolmonth, strdate, CallPut)
End Function

Public Function GetExpirationDate(ByVal symbol As String)
    GetExpirationDate = TradeAPI.GetExpirationDate(symbol)
End Function

Public Function GetTradeingDays(strSymbol):
    Dim lEndDate
    lEndDate = TradeAPI.GetExpirationDate(strSymbol)
    GetTradeingDays = TradeAPI.GetTradeingDays(strSymbol, lEndDate)
End Function

Public Function GetSymbol_ticksize(ByVal symbol As String)
    GetSymbol_ticksize = TradeAPI.GetInstrumentInfo("2", symbol)
End Function

Public Function GetSymbol_session(ByVal symbol As String)
    GetSymbol_session = TradeAPI.GetInstrumentInfo("3", symbol)
End Function

Public Function GetSymbolvolume_multiple(ByVal symbol As String)
    GetSymbolvolume_multiple = TradeAPI.GetInstrumentInfo("6", symbol)
End Function

Public Function GetSymbol_id(ByVal symbol As String)
    GetSymbol_id = TradeAPI.GetInstrumentInfo("Instrument", symbol)
End Function

Public Function GetSymbol_allinfo(ByVal symbol As String)
    GetSymbol_allinfo = TradeAPI.GetInstrumentInfo("ALL", symbol)
End Function


Public Sub ReqSymbolFromdatetime(symboltype, dt):
    Call TradeAPI.TopicSub("ICECREAM.RETURN")
    Call TradeAPI.TopicPublish("ICECREAM.RECOVER", Int(dt), symboltype, Null)
End Sub

